=== debian/changelog ===
jeolib-miallib (1.1.6-2) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Team upload.
  * Add patch to fix FTBFS with GCC 15.
    (closes: #1096871)
  * Add symbols file.
  * Update lintian overrides.
  * Strip build path from miallib-config.cmake.
  * Add patch to fix spelling errors.

  [ Francesco Paolo Lovergine ]
  * Minimal changes to descriptions in d/control.
  * Fixed d/rules to manage correctly the .cmake output file (needs a proper
    fix in CMakeLists.txt)

 -- Francesco Paolo Lovergine <frankie@debian.org>  Mon, 24 Feb 2025 20:51:47 +0100

jeolib-miallib (1.1.6-1) unstable; urgency=medium

  * New upstream release with more changes to original myhull.c module.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 25 Sep 2024 17:40:48 +0200

jeolib-miallib (1.1.5-2) unstable; urgency=medium

  * Updated d/copyright to reflect removing of non-free chull.c source file.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 11 Sep 2024 18:29:19 +0200

jeolib-miallib (1.1.5-1) unstable; urgency=medium

  * New upstream version, with removing ofi a non-free file (closes: #1074409).
  * Debian patch for std99 merged upstream.

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 11 Sep 2024 12:36:10 +0200

jeolib-miallib (1.1.3-1) unstable; urgency=medium

  * Initial release. 

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 03 Jul 2024 15:58:31 +0200
