=== debian/control ===
Source: jeolib-miallib
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libfann-dev,
               libfftw3-dev,
               libgdal-dev,
               libgeotiff-dev,
               libgsl-dev,
               libjsoncpp-dev,
               libopenblas-dev,
               libproj-dev,
               libshp-dev,
               libssl-dev,
               pkgconf,
               swig,
               uthash-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/jeolib-miallib
Vcs-Git: https://salsa.debian.org/debian-gis-team/jeolib-miallib.git
Homepage: https://github.com/ec-jrc/jeolib-miallib
Rules-Requires-Root: no

Package: libmiallib-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmiallib1 (= ${binary:Version}),
         ${misc:Depends}
Recommends: pkgconf
Description: JRC morphological and image processing library - Development files
 Miallib is a C library including image processing and 
 mathematical morphology algorithms used by Join Research Center
 in their Big Data Analytics Platform, with binding for Python
 provided.
 .
 This package contains the files needed to develop a software that
 will use the Miallib (headers, static objects, configuration script).

Package: libmiallib1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: JRC morphological and image processing library
 Miallib is a C library including image processing and 
 mathematical morphology algorithms used by Join Research Center
 in their Big Data Analytics Platform, with binding for Python
 provided.
 .
 This package contains the shared library.
