=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND = -Wno-deprecated-declarations
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem cmake --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DCMAKE_INSTALL_PREFIX=/usr \
 	-DINCLUDE_INSTALL_DIR=include/miallib \
 	-DLIBRARY_INSTALL_DIR=usr/lib/$(DEB_BUILD_MULTIARCH) \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo

execute_after_dh_auto_install:
	sed -i -e "s|$(CURDIR)/build||g" -e "s|/include|/usr/include|" debian/tmp/usr/lib/*/cmake/miallib/miallib-config.cmake
