## jeolib-miallib 1.1.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,7 +32,7 @@
 
 set (MIALLIB_VERSION_MAJOR 1)
 set (MIALLIB_VERSION_MINOR 1)
-set (MIALLIB_VERSION_PATCH 6)
+set (MIALLIB_VERSION_PATCH 7)
 set (MIALLIB_VERSION "${MIALLIB_VERSION_MAJOR}.${MIALLIB_VERSION_MINOR}.${MIALLIB_VERSION_PATCH}")
 set (MIALLIB_SOVERSION "${MIALLIB_VERSION_MAJOR}")
 
@@ -198,7 +198,7 @@
   ${MIALLIB_SRC_DIR}/mslabel.h
   ${MIALLIB_SRC_DIR}/msmm.c
   ${MIALLIB_SRC_DIR}/mspa.c
-  ${MIALLIB_SRC_DIR}/myhull.cc
+  ${MIALLIB_SRC_DIR}/myhull.c
   ${MIALLIB_SRC_DIR}/myhull.h
   ${MIALLIB_SRC_DIR}/natngbint.c
   ${MIALLIB_SRC_DIR}/newlabelcc.c
