=== debian/changelog ===
jeolib-miallib (1.1.7-2) unstable; urgency=medium

  * Team upload.
  * Use test-build-validate-cleanup instead of test-build-twice.
  * Add patch to fix library installation path.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Oct 2025 17:41:03 +0200

jeolib-miallib (1.1.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Don't include debian revision in symbols version.
  * Update symbols for 32-bit architectures.
  * Enable Salsa CI.
  * Bump Standards-Version to 4.7.2, no changes.
  * Update lintian overrides.
  * Drop Rules-Requires-Root: no, default since dpkg 1.22.13.
  * Update copyright file.
  * Drop patches, applied upstream.
  * Update symbols for 1.1.7.
  * Simplify rules.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Oct 2025 09:15:55 +0200
