=== debian/control ===
--- 
+++ 
@@ -18,11 +18,10 @@
                pkgconf,
                swig,
                uthash-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/jeolib-miallib
 Vcs-Git: https://salsa.debian.org/debian-gis-team/jeolib-miallib.git
 Homepage: https://github.com/ec-jrc/jeolib-miallib
-Rules-Requires-Root: no
 
 Package: libmiallib-dev
 Architecture: any
@@ -32,7 +31,7 @@
          ${misc:Depends}
 Recommends: pkgconf
 Description: JRC morphological and image processing library - Development files
- Miallib is a C library including image processing and 
+ Miallib is a C library including image processing and
  mathematical morphology algorithms used by Join Research Center
  in their Big Data Analytics Platform, with binding for Python
  provided.
@@ -46,10 +45,9 @@
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: JRC morphological and image processing library
- Miallib is a C library including image processing and 
+ Miallib is a C library including image processing and
  mathematical morphology algorithms used by Join Research Center
  in their Big Data Analytics Platform, with binding for Python
  provided.
  .
  This package contains the shared library.
-
